
// Multi-dimensional loop

#include <iostream.h>


// Minimise maximum number of virtual processes on any physical process

int* n ;
int* opt ;
int load ;

void operate(int i [], int r) {
  int d, loadi ;

  loadi = 1 ;
  for(d = 0 ; d < r ; d++)
    loadi *= (i [d] + n [d]) / (i [d] + 1) ;

  if(loadi < load) {
    load = loadi ;
    for(int d = 0 ; d < r ; d++)
      opt [d] = i [d] + 1 ;
  }
}


// Loop test: product of i + 1's <= p

int p ;

int test(int d, int i [], int r) {
  int e, prod = 1 ;

  for(e = 0 ; e <= d ; e++)
    prod *= i [e] + 1 ;

  return prod <= p ;
}


// Fairly general r-dimensional loop...

void iterate(int d, int i [], int r) {
  if(d == r)
    operate(i, r) ;
  else
    for(i [d] = 0 ; test(d, i, r) ; i [d] ++)
      iterate(d + 1, i, r) ;
}

int main() {
  int r, d ;

  // Get shape of virtual process array

  cout << "r?: " ;
  cin >> r ;

  n = new int [r] ;

  for(d = 0 ; d < r ; d++) {
    cout << "n_" << d + 1 << "?: " ;
    cin  >> n [d] ;
  }

  // Get number of physical processes

  cout << "p?: " ;
  cin >> p ;

  // Worst case---sequential single-processor mapping
  opt  = new int [r] ;
  load = 1 ;
  for(d = 0 ; d < r ; d++) {
    opt [d] = 1 ;
    load *= n [d] ;
  }

  int* i = new int [r] ;

  iterate(0, i, r) ;

  // Print optimum.

  for(d = 0 ; d < r ; d++)
    cout << "p_" << d + 1 << " = " << opt [d] << "\n" ;
  cout << "load = " << load << "\n" ;

  delete i ;
  delete opt ;
  delete n ;
}

